<?php
require_once "dbpdo.php";
sec_session_start();

if (!login_check())
{
	die (json_encode(array ("err" => 1, "mex" => "Credenziali non valide")));
}
$params = getJParams();


$f = $params->f;//getVal("f", "2016-11-01");
$t = $params->t; //getVal("t", "2016-12-01");

$sw = "";

if ($params != null)
{
    if ($params->category != null)
    {
        $sw .= sprintf("category_id=%d ", $params->category);
    }

    if ($params->inner != null)
    {
        $sw .= sprintf("%srespid=%d ", $sw == "" ? "" : " AND ", $params->inner);
    }

    if ($params->outer != null)
    {
        $sw .= sprintf("%scontact_id=%d ", $sw == "" ? "" : " AND ", $params->outer);
    }

    if ($params->status != null)
    {
        if ($params->status == 1)
        {
            $sw .= sprintf("%s(item_status IS NULL OR item_status=%d) ", $sw == "" ? "" : " AND ", $params->status);
        }
        else if ($params->status == 2)
        {
            $sw .= sprintf("%s(((item_status = null OR item_status = 1) AND ADDDATE(mdate, interval IFNULL(mlong, 0) HOUR) < NOW()) OR (item_status = 3 AND DATE(ADDDATE(mdate, interval IFNULL(mlong, 0) HOUR)) < DATE(closed))) ", $sw == "" ? "" : " AND ", $params->status);
        }
        else $sw .= sprintf("%sitem_status=%d ", $sw == "" ? "" : " AND ", $params->status);

    }

    if ($params->priority != null)
    {
        if ($params->priority == 4)
        {
            $sw .= sprintf("%spriority_kind>=2 ", $sw == "" ? "" : " AND ");
        }
        else $sw .= sprintf("%spriority_kind=%d ", $sw == "" ? "" : " AND ", $params->priority);
    }

    if ($sw != "") $sw = " WHERE ".$sw;
}


$sql = "select * from (
select IFNULL(ri.item_date, x.date) as date, WEEKDAY(IFNULL(ri.item_date, x.date)) as wd, x.name, x.midid, x.rid, x.contact_id, x.place_id, x.place, x.start_time, x.duration, x.category_id, x.ritem_id,
ri.id, ri.manteinance_id, ri.recursion_id, ri.recursion_progressive, ri.closed, ri.closed_by, ri.item_status, ri.notes, c.archive_as, p.description, p.building, ct.category_color, IFNULL(ri.responsible_id, x.mrid) as respid,
concat(u.name, ' ', u.surname) as respname, x.note1, ri.item_date, x.date as mdate, x.dmandatory as mlong, x.priority_kind, c.phone, c.handy, c.email, c.company
 from (

select cal.date, weekday(cal.date) dw, m.name, manteinance_id as midid, r.id as rid, m.contact_id, m.place_id, m.place, m.start_time, m.duration, m.category_id, m.responsible_id as mrid, m.note as note1, m.dmandatory, m.priority_kind,

case
	when m.recursive_kind = 1 then
		timestampdiff(day, m.start_from, cal.date) / (IFNULL(r.repeat_interval_day, 1))
	when m.recursive_kind = 2 then
		cast(floor(timestampdiff(week, m.start_from, cal.date)) * BIT_COUNT(r.repeat_weekday) / IFNULL(r.repeat_interval_week, 1) + bit_count((1 << weekday(cal.date)  | ((1 << weekday(cal.date)) - 1)) & r.repeat_weekday) - 1 as signed)
	when r.repeat_monthyear IS NOT NULL then
		cast(floor(timestampdiff(year, m.start_from, cal.date)) * IFNULL(BIT_COUNT(r.repeat_monthyear), 1) + bit_count((1 << MONTH(cal.date)  | ((1 << MONTH(cal.date)) - 1)) & r.repeat_monthyear) - 1 as signed)
	else
		cast(floor(timestampdiff(month, m.start_from, cal.date) / IFNULL(r.repeat_interval_month, 1) / IFNULL(r.repeat_interval_year * 12, 1)) as signed)
	end as ritem_id


 from

(select ((curdate() - interval 2 year) + interval (x.i * 1000 + t.i * 100 + u.i * 10 + v.i) day) AS Date
from ints t join ints u join ints v join ints x having Date BETWEEN @FROM AND @TO order by t.i, u.i, v.i) cal
 join
`manteinances` m on m.start_from <= cal.date and (m.end_to is null or m.end_to > cal.date) join recursions r on r.manteinance_id = m.id and (
(r.repeat_interval_year is null OR TIMESTAMPDIFF(YEAR, m.start_from, cal.date) % r.repeat_interval_year = 0) AND
(r.repeat_interval_month is null OR TIMESTAMPDIFF(MONTH, m.start_from, cal.date) % r.repeat_interval_month = 0) AND
(r.repeat_interval_day is null OR TIMESTAMPDIFF(DAY, m.start_from, cal.date) % r.repeat_interval_day = 0) AND
(r.repeat_interval_week is null OR TIMESTAMPDIFF(WEEK, m.start_from, cal.date) % r.repeat_interval_week = 0) AND

(r.repeat_weekday is null OR (r.repeat_weekday & (1 << weekday(cal.date))) > 0) AND
(r.repeat_year is null OR r.repeat_year = year(cal.date)) AND
(r.repeat_month is null OR r.repeat_month = month(cal.date)) AND

(r.repeat_monthyear is null OR (r.repeat_monthyear & (1 << (MONTH(cal.date)-1))) > 0) AND

(r.repeat_day is null OR (r.repeat_day > 32 AND LAST_DAY(cal.date) = cal.date) OR r.repeat_day = day(cal.date)) AND
(r.repeat_weeknum is null OR r.repeat_weeknum = WEEKOFYEAR(cal.date)) AND
(r.repeat_weekmonth is null OR
r.repeat_weekmonth = floor((DAYOFMONTH(cal.date)-1)/7)
OR (r.repeat_weekmonth = 6 AND DATEDIFF(LAST_DAY(cal.date), cal.date) < 8)


)

)  order by cal.date, start_time
) x left join recursions_items ri ON ri.manteinance_id = x.midid AND ri.recursion_id = x.rid AND ri.recursion_progressive = x.ritem_id
left join contacts c ON x.contact_id = c.id left join places p ON x.place_id = p.id left join categories ct on ct.id = x.category_id  left join users u on u.id = IFNULL(ri.responsible_id, x.mrid)

UNION ALL
SELECT IFNULL(ri.item_date, t.start_from) as date, weekday(IFNULL(ri.item_date, t.start_from)) as dw, t.name, t.id as midid, 0 as rid, contact_id, place_id, place, start_time, duration, category_id, 0 as ritem_id,
ri.id, ri.manteinance_id, ri.recursion_id, ri.recursion_progressive, ri.closed, ri.closed_by, ri.item_status, ri.notes, c.archive_as, p.description, p.building, ct.category_color, IFNULL(ri.responsible_id, t.responsible_id) as respid,
concat(u.name, ' ', u.surname) as respname, t.note as note1, ri.item_date, start_from as mdate, dmandatory as mlong, t.priority_kind, c.phone, c.handy, c.email, c.company
FROM `manteinances` t left join recursions_items ri ON ri.manteinance_id = t.id
left join contacts c ON t.contact_id = c.id left join places p ON t.place_id = p.id left join categories ct on ct.id = category_id left join users u on u.id = IFNULL(ri.responsible_id, t.responsible_id)
where recursive_kind IS NULL AND (date(start_from) <= @TO AND ADDDATE(start_from, INTERVAL dmandatory DAY) >= @FROM)


UNION ALL
SELECT ri.item_date as date, weekday(ri.item_date) as dw, m.name, m.id as midid, ri.recursion_id, m.contact_id, m.place_id, m.place, m.start_time, m.duration, m.category_id, ri.recursion_progressive as ritem_id, ri.id, ri.manteinance_id, ri.recursion_id, ri.recursion_progressive,
ri.closed, ri.closed_by, ri.item_status, ri.notes, c.archive_as, p.description, p.building, ct.category_color, IFNULL(ri.responsible_id, m.responsible_id) as respid,
concat(u.name, ' ', u.surname) as respname, m.note as note1, ri.item_date, m.start_from as mdate, m.dmandatory as mlong, m.priority_kind, c.phone, c.handy, c.email, c.company
FROM manteinances m JOIN recursions_items ri ON ri.manteinance_id = m.id AND ri.item_date BETWEEN @FROM AND @TO AND ri.orig_date NOT BETWEEN @FROM AND @TO
LEFT JOIN contacts c ON m.contact_id = c.id LEFT JOIN places p ON m.place_id = p.id LEFT JOIN categories ct ON ct.id = category_id LEFT JOIN users u ON u.id = IFNULL(ri.responsible_id, m.responsible_id)



UNION ALL
select IFNULL(ri.item_date, x.date) as date, WEEKDAY(IFNULL(ri.item_date, x.date)), x.name, x.midid, x.rid, x.contact_id, x.place_id, x.place, x.start_time, x.duration, x.category_id, x.ritem_id,
ri.id, ri.manteinance_id, ri.recursion_id, ri.recursion_progressive, ri.closed, ri.closed_by, ri.item_status, ri.notes, c.archive_as, p.description, p.building, ct.category_color, IFNULL(ri.responsible_id, x.mrid) as respid,
concat(u.name, ' ', u.surname) as respname, x.note1, ri.item_date, x.date as mdate, x.dmandatory as mlong, x.priority_kind, c.phone, c.handy, c.email, c.company
 from (

select cal.date, weekday(cal.date) dw, m.name, manteinance_id as midid, r.id as rid, m.contact_id, m.place_id, m.place, m.start_time, m.duration, m.category_id, m.responsible_id as mrid, m.note as note1, m.dmandatory, m.priority_kind,

case
	when m.recursive_kind = 1 then
		timestampdiff(day, m.start_from, cal.date) / (IFNULL(r.repeat_interval_day, 1))
	when m.recursive_kind = 2 then
		cast(floor(timestampdiff(week, m.start_from, cal.date)) * BIT_COUNT(r.repeat_weekday) / IFNULL(r.repeat_interval_week, 1) + bit_count((1 << weekday(cal.date)  | ((1 << weekday(cal.date)) - 1)) & r.repeat_weekday) - 1 as signed)
	when r.repeat_monthyear IS NOT NULL then
		cast(floor(timestampdiff(year, m.start_from, cal.date)) * IFNULL(BIT_COUNT(r.repeat_monthyear), 1) + bit_count((1 << MONTH(cal.date)  | ((1 << MONTH(cal.date)) - 1)) & r.repeat_monthyear) - 1 as signed)
	else
		cast(floor(timestampdiff(month, m.start_from, cal.date) / IFNULL(r.repeat_interval_month, 1) / IFNULL(r.repeat_interval_year * 12, 1)) as signed)
	end as ritem_id


 from


(select ((curdate() - interval 2 year) + interval (x.i * 1000 + t.i * 100 + u.i * 10 + v.i) day) AS Date
from ints t join ints u join ints v join ints x having Date between ADDDATE(@FROM, INTERVAL - 30 DAY) AND @FROM order by t.i, u.i, v.i) cal
 join
`manteinances` m on (m.start_from <= cal.date AND m.dmandatory > 1 and (m.end_to is null or m.end_to > cal.date) AND ADDDATE(cal.date, INTERVAL m.dmandatory DAY) >= @FROM)

AND cal.date not between @FROM AND @TO

join recursions r on r.manteinance_id = m.id and (
(r.repeat_interval_year is null OR TIMESTAMPDIFF(YEAR, m.start_from, cal.date) % r.repeat_interval_year = 0) AND
(r.repeat_interval_month is null OR TIMESTAMPDIFF(MONTH, m.start_from, cal.date) % r.repeat_interval_month = 0) AND
(r.repeat_interval_day is null OR TIMESTAMPDIFF(DAY, m.start_from, cal.date) % r.repeat_interval_day = 0) AND
(r.repeat_interval_week is null OR TIMESTAMPDIFF(WEEK, m.start_from, cal.date) % r.repeat_interval_week = 0) AND

(r.repeat_weekday is null OR (r.repeat_weekday & (1 << weekday(cal.date))) > 0) AND
(r.repeat_year is null OR r.repeat_year = year(cal.date)) AND
(r.repeat_month is null OR r.repeat_month = month(cal.date)) AND

(r.repeat_monthyear is null OR (r.repeat_monthyear & (1 << (MONTH(cal.date)-1))) > 0) AND

(r.repeat_day is null OR (r.repeat_day > 32 AND LAST_DAY(cal.date) = cal.date) OR r.repeat_day = day(cal.date)) AND
(r.repeat_weeknum is null OR r.repeat_weeknum = WEEKOFYEAR(cal.date)) AND
(r.repeat_weekmonth is null OR
r.repeat_weekmonth = floor((DAYOFMONTH(cal.date)-1)/7)
OR (r.repeat_weekmonth = 6 AND DATEDIFF(LAST_DAY(cal.date), cal.date) < 8)


)

)  order by cal.date, start_time
) x left join recursions_items ri ON ri.manteinance_id = x.midid AND ri.recursion_id = x.rid AND ri.recursion_progressive = x.ritem_id
left join contacts c ON x.contact_id = c.id left join places p ON x.place_id = p.id left join categories ct on ct.id = x.category_id  left join users u on u.id = IFNULL(ri.responsible_id, x.mrid)


) z $sw order by z.date, z.start_time, z.name, z.place";

//$data = array();

//echo "SET @FROM = '$f', @TO = '$t';";
//echo $sql;

//echo "SET @FROM = '$f', @TO = '$t';\r\n";
//echo $sql."\r\n";

$sqlp = "SET @FROM = :from, @TO = :to";

//echo "SET @FROM='$f', @TO='$t';\r\n$sql\r\n";

try
{
    $stmt = $pdo->prepare($sqlp);
    $stmt->bindValue(":from", "$f", PDO::PARAM_STR);
    $stmt->bindValue(":to", "$t", PDO::PARAM_STR);
    $stmt->execute();
}
catch(PDOException $e)
{
    // error handling
}

$stmt = $pdo->prepare($sql);
$stmt->execute(); //['FRM' => $f, 'TO' => $t]);

$data = $stmt->fetchAll(PDO::FETCH_NUM);

header('Content-type: application/json');
echo json_encode( $data );
?>